Spotify Top Tracks Analysis
 
## Description
The Application is for data visualization of top tracks on Spotify and how the elements of the song
(i.e. danceability, genre, explicit, etc.) can affect the popularity score of each song (higher means more popular).
Users can choose parameters 
and graph types to visualize data and the application will show the graph on the screen

![Sequence diagram](https://github.com/SirisilpK/year-project-woraamy/assets/113490970/5876be28-b2f0-4689-8730-99b67621a6e3)
![Final Project Diagram-2](https://github.com/SirisilpK/year-project-woraamy/assets/113490970/8b5b0b9c-9773-4e74-af5a-880d38c47684)
[Youtube Link](https://youtu.be/yxaeZpPuDXQ)


## Data Sources
[Spotify Top Tracks](https://www.kaggle.com/datasets/maharshipandya/-spotify-tracks-dataset)

Meaning of each column

* popularity: The popularity of a track is a value between 0 and 100, with 100 being the most popular.
* explicit: Whether or not the track has explicit lyrics (true = yes, false = no)
* danceability: How suitable a track is for dancing based on a combination of musical elements.
* energy: Energy represents a perceptual measure of intensity and activity.
* key: The key the track is in. Integers map to pitches using standard Pitch Class notation.
* loudness: The overall loudness of a track in decibels (dB)
* mode: The modality (major or minor) of a track.
* speechiness: The presence of spoken words in a track.
* acousticness: A confidence measure from 0.0 to 1.0 of whether the track is acoustic.
* instrumentalness: Predicts whether a track contains no vocals.
* liveness: Detects the presence of an audience in the recording.
* valence: The musical positiveness conveyed by a track.
* tempo: The overall estimated tempo of a track in beats per minute (BPM).
* time_signature: An estimated time signature.
* track_genre: The genre in which the track belongs
 
## Running the Application
* pandas
* matplotlib
* numpy
 
## Design
There is graph visualization on the left and consolde to interact with user on the right
 
## Design Patterns Used
The application uses Layered Architecture pattern by using class GraphVis, HistogramVis, BoxPlot, ScatterPlot, PieChartVis
to process the data with data processed in class SpotifyData
and show it to the user using class Application to be the external layer
 
## Graph Algorithm Used
Vertices: Artists, Genre Acoustic
Edges: Songs from artist that are in the genre acoustic
Weight: None
Problem: Given a non-negative-weighted Graph G and a vertex acoustic and artist in G, Is there a path from acoustic and artist?
Algorithm: WHATEVERFIRSTSEARH from acoustic node to artist node, and check whether artist is marked.

 

